.TH PUFF  1 "February 17, 1992" "AHPCRC"
.SH NAME
puff \- An X program for sight impaired users
.SH SYNOPSIS
\fBpuff\fR [ \-toolkit_option ] [ \-option ]
.SH DESCRIPTION
\fIPuff\fR is intended for people who need text and graphics 
displayed at a high
magnification factor.  Typically users will want both the pointer and
text to be tracked as they work.
.PP
\fIPuff\fR follows the pointer (aka mouse), magnifying a part of
the screen under the cursor.  In addition, \fIpuff\fR can monitor
the X11 protocol of X clients and magnify the region where graphics
were last drawn.  By monitoring a program like \fIxterm\fR,
\fIpuff\fR can follow the text cursor automatically.
\fIPuff\fR switches focus between the pointer and graphics
depending on which was last active.
.PP
In order to track the protocol of X clients, \fIpuff\fR sets up a
false server on the machine that it is executed on.  This server is by
default at display number 1.  Any X clients
connecting with this false server are connected to
the same X server that \fIpuff\fR is connected to.  \fIPuff\fR
is transparent to X clients.
.PP
\fIPuff\fR draws a box around the location being magnified,
which makes it easier to track the cursor and see where \fIpuff\fR
is focusing its attention.
The view box flashes on each update.
.SH INTERFACE
\fIPuff\fR is controlled via the keyboard.  The following keys
have these actions:
.IP "1-9, 0, -, ="
Change the magnification factor to 2-18, 20, 25 and 30 respectively.
.IP "b, B"
Toggle showing the view box.
.IP "q, Q, Escape"
Quit \fIpuff\fR.  This will also finish off any clients running though
\fIpuff\fR.
.PP
The following arrow key commands make it easier to scan text and graphics.
.IP "<Ctrl>Up"
Move the magnification window up by 1/4 the window height. 
.IP "<Ctrl>Down"
Move the magnification window down by 1/4 the window height. 
.IP "<Ctrl>Right"
Move the magnification window right by 1/4 the window width. 
.IP "<Ctrl>Left"
Move the magnification window left by 1/4 the window width. 
.IP "<Ctrl>Return"
Return to the point of interest. 
.SH OPTIONS
.IP "-d | -dnum \fIinteger\fR  (resource:  Puff.displayNumber)"
Have \fIpuff\fR's false server listen at a different display number.
By default, \fIpuff\fR listens to display number 1.
.IP "-m | -mag \fIinteger\fR  (resource:  Puff*Mag)"
Set the magnification factor.  The magnification is constrained to
be an integer greater than zero.  The default is 6.
.IP "-u | -update \fIinteger\fR  (resource:  Puff*delayMax)"
Specify in milliseconds how often to update the puff window
in the absence of pointer of graphics activity.
For example, to update every second use a value of 1000.
The default update rate is 500 milliseconds, or 2 Hz.  An update
value of zero turns off periodic updating.
.IP "-c | -cwidth \fIinteger\fR  (resource:  Puff*cursorWidth)"
Specify the size of the pointer cursor block in the puff window.  The
actual dimension of the block is '2\ *\ cursorWidth\ *\ magnification'.
The default cursor width is 3. The width of the view box outline
is 'cursorWidth\ +\ magnification'.
.IP "-h | -help"
Display a short command summary.
.SH ADDITIONAL RESOURCES
The following resources apply to the \fIpuff\fR widget, of
class \fIPuff\fR.
.IP "magX: \fIinteger\fR   (Class: Mag)"
Set the magnification factor in the horizontal direction.
The resource value must be a positive integer.
.IP "magY: \fIinteger\fR   (Class: Mag)"
Set the magnification factor in the vertical direction.
The resource value must be a positive integer.
.IP "delayMin: \fImilliseconds\fR  (Class: DelayMin)"
Graphics and pointer activity are accumulated for delayMin
milliseconds before \fIpuff\fR updates, to avoid 
overwhelming the X server.  To decrease \fIpuff\fR's
impact, increase delayMin.  The default value is 50 milliseconds,
or 20 Hz.
.IP "viewBox: \fIinteger\fR  (Class: ViewBox)"
If the viewBox resource is non-zero the view box will be drawn.
.SH EXAMPLE
In practice \fIpuff\fR is often used on the top half of the
screen, with clients running on the bottom half.  A 
sample \fI.xsession\fR file might read:
.nf
.IP
#!/bin/csh
xrdb -load $HOME/.Xdefaults
xclock -geometry -10-10 &
puff -geometry 1280x500+0+0 &
xterm -display :1 -geometry 80x32+5-5 &
twm
.fi
.PP
For yucks, while \fIpuff\fR is running try:
.IP
xclock -display :1 -u 1
.SH CAVEATS
If run over a network, \fIpuff\fR can consume a good portion of an
ethernet's bandwidth.  To be a good citizen, run \fIpuff\fR on the
same workstation as the X server whenever possible.
.PP
If available, \fIPuff\fR will use the MIT Shared Memory X server
extension, which greatly improves performance.  However, if terminated
with extreme prejudice (i.e. kill -9), the program will not have a
chance to release the shared memory segments it was using.  The
program \fIipcrm\fR can be used to clean up \fIpuff\fR's mess.
.PP
\fIPuff\fR will grab all <Ctrl>arrow-key events, depriving other
clients.  This obnoxious behavior should be made an option.
.SH AUTHOR
Ken Chin-Purcell, AHPCRC, Minnesota Supercomputer Center.
.br
Mail to ken@msc.edu.
