/*
 * $Id: util.h,v 1.3 92/02/04 14:36:56 ken Exp Locker: ken $
 * $Date: 92/02/04 14:36:56 $
 *
 * Author:	Kenneth Chin-Purcell, AHPCRC
 *		Copyright @ 1992, Minnesota Supercomputer Center, Inc.
 *
 * Purpose:	General utilities
 *
 * RESTRICTED RIGHTS LEGEND
 *
 * Use, duplication, or disclosure of this software and its documentation
 * by the Government is subject to restrictions as set forth in subdivision
 * { (b) (3) (ii) } of the Rights in Technical Data and Computer Software
 * clause at 52.227-7013.
 *
 * $Log:	util.h,v $
 * Revision 1.3  92/02/04  14:36:56  ken
 * Remove wcl, cleanup
 * 
 */

#include <malloc.h>
#include <string.h>
#include <stdio.h>

#ifdef ultrix
typedef	char	*VoidPtr;
#else
typedef	void	*VoidPtr;
#endif

#ifndef MIN
#define MIN(i,j)  ((i)<(j) ? (i) : (j))
#endif
#ifndef MAX
#define MAX(i,j)  ((i)>(j) ? (i) : (j))
#endif
#ifndef ABS
#define ABS(i)    ((i)> 0  ? (i) : -(i))
#endif

#define MATCH(sa,sb)	(strncmp(sa, sb, strlen(sb)) == 0)

#define MallocType(type)	(type *) malloc(sizeof(type))
#define CallocType(type,i)	(type *) calloc(i,sizeof(type))
#define Free(ptr)		if (ptr) free(ptr)

#define Zero(ptr,size)		(void) memset(ptr, 0, size)
#define ZeroType(ptr,type)	Zero(ptr, sizeof(type))
#define Copy(dst,src,size)	(void) memcpy(dst, src, size)
#define CopyType(dst,src,type)	Copy(dst, src, sizeof(type))

#define Verify(expr,estr)	if (!(expr)) BailOut(estr,__FILE__,__LINE__)
#define MemCheck(ptr)	if (!(ptr)) BailOut("Out of memory",__FILE__,__LINE__)


/* Prototypes */

/* util.c */
void	Error (char *desc);
void	BailOut (char *desc, char *fname, int lineno);
long	FindFileSize (char *fname);
void	ReadCmap (short cmap [256 ][3 ], char *cmapName);
char	*NewString (char *old, int extra);
int	NameMatch (char *str1, char *str2);
void	CommaLong (char *s, long i);
long	Factor (long a);
long	RoundUp (long a, long modulo);
long	*MakeLongArray (long num);
float	*MakeFloatArray (long num);
char	*ReadString (FILE *file);
long	ReadLong (FILE *file);
float	ReadFloat (FILE *file);
char	*ReadToken (FILE *file);
int	PositionAtString (char *s, FILE *file);
void	ReadFloatArray (float *farr, long num, FILE *file);
void	ReadLongArray (long *larr, long num, FILE *file);
int	BigEndFirst (void);
int	Round (float x);
